<?php

// Get Start and End Dates

$start_date = date('Y-m-d', mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
$end_date = date('Y-m-d', strtotime(current_time('mysql')));

if ( isset($_GET['start_date']) ) {
	$post_start_date = urldecode($_GET['start_date']);
}

if ( isset($_GET['end_date']) ) {
	$post_end_date = urldecode($_GET['end_date']);
}

if (isset($post_start_date) && $post_start_date != '') {
	$start_date = date('Y-m-d', strtotime($post_start_date));
}

if (isset($post_end_date) && $post_end_date != '') {
	$end_date = date('Y-m-d', strtotime($post_end_date));
}

// Export data

if (isset($_GET['export_data']) && $_GET['export_data'] == 'true' && check_admin_referer(self::$prefix . 'stats_list_export')) {

	$stats_tracker = new NNR_Stats_Tracker_v1( self::$stats_table_name );
	$stats = $stats_tracker->get_stats($start_date, $end_date);

	$stats_display = new NNR_Stats_Tracker_Display_v1('');
	$stats = $stats_display->add_empty_data($start_date, $end_date, $stats);

	$filename =  self::$prefix . 'stats.csv';
	$export_file = fopen(NNROBOTS_INTERSTITIAL_OVERLAYS_PLUGIN_DIR . 'exports/' . $filename, "w");
	fputcsv($export_file, array('Interstitial Overlay', 'Date', 'Impressions', 'Conversions'));

	foreach ( array_reverse($stats) as $stat ) {

		$data_manager = new NNR_Data_Manager_v1( self::$data_manager_table_name );

		$output_array = array(
			$data_manager->get_name_from_id($stat['data_id']),
			$stat['date'],
			$stat['impressions'],
			$stat['conversions'],
		);

	    fputcsv($export_file, $output_array);
	}

	fclose($export_file);

	?>
	<script type="text/javascript">
		window.location = '<?php echo NNROBOTS_INTERSTITIAL_OVERLAYS_PLUGIN_URL . '/exports/download.php?filename=' . $filename; ?>';
	</script>
	<?php
}

$stats_display = new NNR_Stats_Tracker_Display_v1( self::$stats_table_name, array(
	'prefix'			=> self::$prefix_dash,
	'text_domain'		=> self::$text_domain,
	'stats_page'		=> self::$stats_page,
	'data_table_name'	=> self::$data_manager_table_name,
));

include_once(NNROBOTS_INTERSTITIAL_OVERLAYS_PLUGIN_DIR . 'views/stats.php');